// Copyright © 2023 ESWIN. All rights reserved.
//
// Beijing ESWIN Computing Technology Co., Ltd and its affiliated companies ("ESWIN") retain
// all intellectual property and proprietary rights in and to this software. Except as expressly
// authorized by ESWIN, no part of the software may be released, copied, distributed, reproduced,
// modified, adapted, translated, or created derivative work of, in whole or in part.

#ifndef ESWIN_DSP_COMMON_MEM_H_
#define ESWIN_DSP_COMMON_MEM_H_

#include <xtensa/xtruntime.h>

static inline uint32_t dsp_reg_read(volatile void *p)
{
    uint32_t v = *(const volatile uint32_t *)p;
    return v;
}

static inline void dsp_reg_write(uint32_t v, volatile void *p)
{
    XT_MEMW();
    *(volatile uint32_t *)p = v;
}

static inline void dsp_cache_invalidate(void *addr, size_t len) { xthal_dcache_region_invalidate(addr, len); }

static inline void dsp_invalid_icache(void *addr, size_t len) { xthal_icache_region_invalidate(addr, len); }

static inline void dsp_cache_flush(void *addr, size_t len) { xthal_dcache_region_writeback(addr, len); }

static inline void dsp_cache_flush_invalidate(void *addr, size_t len) { xthal_dcache_region_writeback_inv(addr, len); }

#endif  // ESWIN_DSP_COMMON_MEM_H_
