/*
 * Copyright (c) 2019 by Tensilica Inc. ALL RIGHTS RESERVED.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
#include "xt_mld_loader.h"
#include "xt_mld_loader_internal.h"

/*
 * This function writes information about the packaged library into
 * the info structure.
 */
const char* xtmld_error_string(xtmld_result_code_t x)
{
    switch (x)
    {
    case xtmld_success:
        return "No Error.";
    case xtmld_null_ptr:
        return "Function improperly called with NULL pointer.";
    case xtmld_invalid_library:
        return "Invalid library format.";
    case xtmld_internal_error:
        return "Internal error.";
    case xtmld_local_memory_required:
        return "Local memory was required for some library sections, but it was not provided.";
    case xtmld_mem_require_not_found:
        return "Memory requirements not found. Use XTMLD_CODE_MEM_REQ and XTMLD_DATA_MEM_REQ macros to specify memory requirements for library.";
    case xtmld_code_must_be_in_1gig_region:
        return "Attempt to load code outside 1-gig range.";
    case xtmld_sections_overlap:
        return "Section addresses overlap.";
    case xtmld_image_not_aligned:
        return "Library is not properly aligned.";
    default:
        return "Unknown error.";
    }
}
