#!/bin/bash
set -e

sys_root_dir=null
kernel_config_dir=null

function usage() {
    echo -e "Usage:\n$0 <sys_root_dir> <kernel_config_dir>"
}

function main() {
    if [ $# -le 1 ]; then
        usage
        exit 1
    fi

    sys_root_dir=$1
    kernel_config_dir=$2

    if [ ! -d build ]; then
        mkdir -p build
    else
        rm -rf build/*
    fi

    cd build

    export PATH="/opt/riscv/bin:$PATH"
    export ARCH=riscv
    export CROSS_COMPILE=riscv64-unknown-linux-gnu-

    # Run CMake with the specified SYSROOT_PATH
    cmake .. -DSYSROOT_PATH=${sys_root_dir} -DKERNEL_CONFIG_DIR=${kernel_config_dir}

    make
}

main $@
